//	FILENAME:	Stage_Of_Epicness.cs
//
//	AUTHOR:  	:e: Drake
//---------------------------------------------------------------------

$missionName = "Stage Of Epicness";

//---------------------------------------------------------------------
//	Setup the HUD Map to view the area the players will be in.
//---------------------------------------------------------------------
$server::HudMapViewOffsetX = -8055.6;
$server::HudMapViewOffsetY = -8106.5;

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = false;
}

function onMissionStart()
{
	$door = getObjectId("MissionGroup\\floor\\door");
	$fireworks = true;
	$shades = "Closed";
	$delay = "Ok";
	$sound = "Ok";
	$shadeCount = 8;
	$shadeRot = 0;
	$shadeAngle = -90;
}

function player::onAdd(%player)
{
	say(%player, 1, "<JC>Welcome to <F5>" @ $missionName @ "<F0>! Created by :e: Drake");
	%player.points = 100;
	%player.message = false;
	%player.ticket = 1;
	%player.bs = false;
	%player.inShow = false;
	%player.delay = false;
}

function vehicle::onAdd(%vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player.message == false)
	{
		say(%player, 1, "<JC><F5>In order to get a ticket: kill someone for a point then you may buy a ticket.\n\n<F1>You may also use points for other stuff..such as a beer at the bar.");
		%player.message = true;
	}
}

function vehicle::onAttacked(%attacked, %attacker)
{
	%player = playerManager::vehicleIdToPlayerNum(%attacker);

	if(%attacked.inShow == true)
	{
		if(%player.delay == false)
		{
			say(%player, 1, "<F5>You are in a show! You may not cause a fight!");
			schedule("resetDelay(" @ %player @ ");", 2);
		}
		healObject(%attacked, 999999);
	}
}
			

function tb::structure::onScan(%scanned, %scanner)
{
	%player = playerManager::vehicleIdToPlayerNum(%scanner);
	if(%player.points == 0)
	{
		say(%player, 1, "You must have at least 1 point in order to buy a ticket.");
	}
	else
	{
		say(%player, 1, "Thank you for buying a ticket.");
		%player.ticket++;
		%player.points--;
	}
}

function bs::structure::onScan(%scanned, %scanner)
{
	%player = playerManager::vehicleIdToPlayerNum(%scanner);
	if(%player.points < 5)
	{
		say(%player, 1, "Promie Backstage Dude: You must have at least 5 points in order to buy a backstage pass.");
	}
	else
	{
		say(%player, 1, "Promie Backstage Dude: Thank you for buying a backstage pass.");
		%player.bs = true;
		%player.points -= 5;
	}
}

function fireworks::structure::onScan(%scanned, %scanner)
{
	if($fireworks == true)
	{
		$fireworks = false;
		launch(1);
		schedule("launch(2);", 3);
		schedule("launch(3);", 5);
		schedule("$fireworks = true;", 10);
	}
}

function fireworks2::structure::onScan(%scanned, %scanner)
{
	if($fireworks == true)
	{
		$fireworks = false;
		launch(1);
		for(%i = 1; %i < 4; %i++)
		{
			// Launch off 3 sets of fireworks
			// at a 3 second interval.
			schedule("launch(1);", %i * 0.5);
		}
		schedule("$fireworks = true;", 3);
	}
}

function bt::structure::onScan(%scanned, %scanner)
{
	%player = playerManager::vehicleIdToPlayerNum(%scanner);

	if(%player.points < 1)
	{
		say(%player, 1, "Teen Bartender: You require at least 1 point to buy a beer.");
	}
	else
	{
		healObject(%scanner, 999999);
		reloadObject(%scanner, 999999);
		say(%player, 1, "<F6>You are healed and reloaded.");
		%player.points--;
	}
}

function mic::structure::onScan(%scanned, %scanner)
{
	%player = playerManager::vehicleIdToPlayerNum(%scanner);

	if(%player.bs == false)
	{
		say(%player, 1, "You require a Backstage pass in order to play music.");
	}
	else
	{
		%rand = randomInt(1, 5);
		if($sound == "Ok")
		{
			$sound = "Not Ok";
			playSound(0, "scene" @ %rand @ ".wav", IDPRF_2D);
			schedule("$sound = \"Ok\";", 45);
		}
	}
}

function door1::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(%player.inShow == false)
	{
		if(getName(%player) != "Drake")
		{
			if(%player.ticket > 0)
			{
				say(%player, 1, "KNIGHTS: Welcome.");
				playAnimSequence($door, 0, true);
			}
			else
			{
				if(%player.delay == false)
				{
					say(%player, 1, "KNIGHTS: Please buy a ticket before entering.");
					%player.delay = true;
					schedule("resetDelay(" @ %player @ ");", 2);
				}
				playAnimSequence($door, 0, false);
			}
		}
		else
		{
			say(%player, 1, "KNIGHTS: Oh, Drake! Come right in, sir!");
			playAnimSequence($door, 0, true);
		}
	}
	else
	{
		playAnimSequence($door, 0, false);
		%player.inShow = false;
	}
}

function door2::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(getName(%player) != "Drake")
	{
		if(%player.ticket > 0 && %player.inShow == false)
		{
			say(%player, 1, "KNIGHTS: Enjoy the show.");
			playAnimSequence($door, 0, false);
			%player.ticket--;
			%player.inShow = true;
		}
		else if((%player.ticket > 0 || %player.ticket == 0) && %player.inShow == true)
		{
			say(%player, 1, "KNIGHTS: Thank you for coming. We hope you enjoyed the show.");
			playAnimSequence($door, 0, true);
		}
		else
		{
			damageObject(%object, 999999);
			say(%player, 1, "KNIGHTS: You were destroyed for trying to get through without a ticket!");
		}
	}
	else
	{
		if(%player.inShow == false)
		{
			say(%player, 1, "KNIGHTS: Enjoy the show, sir!");
			playAnimSequence($door, 0, false);
			%player.inShow = true;
		}
		else if(%player.inShow == true)
		{
			say(%player, 1, "KNIGHTS: We hope you enjoyed the show, sir!");
			playAnimSequence($door, 0, true);
		}
	}

}

function backstage::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(getName(%player) == "Drake")
	{
		playAnimSequence(getObjectId("MissionGroup\\Stage\\backstage"), 0, true);
	}
	else
	{
		if(%player.bs == true)
		{
			playAnimSequence(getObjectId("MissionGroup\\Stage\\backstage"), 0, true);
		}
		else
		{
			playAnimSequence(getObjectId("MissionGroup\\Stage\\backstage"), 0, false);
		}
	}
}

function backstage::trigger::onLeave(%this, %object)
{
	playAnimSequence(getObjectId("MissionGroup\\Stage\\backstage"), 0, false);
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
	if(%destroyed != %destroyer)
	{
		healObject(%destroyer, 9999999);
		reloadObject(%destroyer, 9999999);
		%rand = randomInt(1,3);
		if(%rand == 1)
		{
			say(0, 0, getHudName(%destroyer) @ "<f0> owned " @ getHudName(%destroyed));
		}
		else if(%rand == 2)
		{
			say(0, 0, getHudName(%destroyer) @ "<f0> dropped kicked " @ getHudName(%destroyed) @ " <f0> into the wall.");
		}
		else
		{
			say(0, 0, getHudName(%destroyer) @ "<f0> did something sexually abusive to " @ getHudName(%destroyed));
		}
		%destroyer.points++;
			
	}
	else
	{
		say(0, 0, getHudName(%destroyed) @ " died.");
	}
	%destroyed.inShow = false;
	%destroyed.bs = false;
}

function moveObject(%object, %axis, %increment)
{
	%x = getPosition(%object, x);
	%y = getPosition(%object, y);
	%z = getPosition(%object, z);

	if(%axis == "X")
	{
		%newX = %x + %increment;
		setPosition(%object, %newX, %y, %z);
	}
	else if(%axis == "Y")
	{
		%newY = %y + %increment;
		setPosition(%object, %x, %newY, %z);
	}
	else if(%axis == "Z")
	{
		%newZ = %z + %increment;
		setPosition(%object, %x, %y, %newZ);
	}
	else
	{
		echo($Console::Prompt @ "ERROR moveObject(%object, %axis, %increment) : Unknown Axis.");
	}
}

function launch(%set)
{
	if(%set == 1)
	{
		for(%i = 1; %i < 5; %i++)
		{
			%launcher[%i] = getObjectId("MissionGroup\\Stage\\SpecialEffects\\set1\\" @ %i);
			%x[%i] = getPosition(%launcher[%i], x);
			%y[%i] = getPosition(%launcher[%i], y);
			%z[%i] = getPosition(%launcher[%i], z);
			%lastHeight[%i] = %z[%i] + 250;
			droppod(%x[%i], %y[%i], %z[%i], %x[%i], %y[%i], %lastHeight[%i]);
		}
	}
	if(%set == 2)
	{
		for(%i = 1; %i < 7; %i++)
		{
			%launcher[%i] = getObjectId("MissionGroup\\Stage\\SpecialEffects\\set2\\" @ %i);
			%x[%i] = getPosition(%launcher[%i], x);
			%y[%i] = getPosition(%launcher[%i], y);
			%z[%i] = getPosition(%launcher[%i], z);
			%lastHeight[%i] = %z[%i] + 250;
			droppod(%x[%i], %y[%i], %z[%i], -7922.19, -7975.17, %lastHeight[%i]);
		}
	}
	if(%set == 3)
	{
		for(%i = 1; %i < 4; %i++)
		{
			%y[%i] = -7975.17 - (%i * 40);
			droppod(-7922.19, %y[%i], 375, -7922.19, %y[%i], 100);
		}
	}
}

		

function debug(%player)
{
	%player.points++;
	if(%player.points > 1)
	{
		echo(getName(%player) @ " now has " @ %player.points @ " points.");
	}
	else
	{
		echo(getName(%player) @ " now has " @ %player.points @ " point.");
	}
}

function resetDelay(%player)
{
	%player.delay = false;
}